<template>
  <main class="bg-white">
    <div class="relative flex">
      <!-- Content -->
      <div class="w-full md:w-1/2">
        <div class="min-h-screen h-full flex flex-col after:flex-1">
          <div class="flex-1">
            <div
              class="
                flex
                items-center
                justify-between
                h-16
                px-4
                sm:px-6
                lg:px-8
              "
            >
              <!-- Logo -->
              <a class="block" href="#">
                <img
                  width="75"
                  height="75"
                  viewBox="0 0 75 75"
                  class="mt-4"
                  src="storage/images/qerja-logo.png"
                  alt="logo"
                />
              </a>
            </div>
          </div>

          <div class="max-w-sm mx-auto px-4 py-8">
            <h1 class="text-3xl text-slate-800 font-bold mb-6">
              Welcome back! ✨
            </h1>
            <!-- Form -->
            <form>
              <div class="space-y-4">
                <div>
                  <label class="block text-sm font-medium mb-1" for="email"
                    >Email Address</label
                  >
                  <input
                    :class="
                      isLoading
                        ? 'form-input w-full disabled:border-slate-200 disabled:bg-slate-100 disabled:text-slate-400 disabled:cursor-not-allowed'
                        : 'form-input w-full'
                    "
                    type="email"
                    v-model="email"
                    :disabled="isLoading"
                  />
                </div>
                <div>
                  <label class="block text-sm font-medium mb-1" for="password"
                    >Password</label
                  >
                  <input
                    :class="
                      isLoading
                        ? 'form-input w-full disabled:border-slate-200 disabled:bg-slate-100 disabled:text-slate-400 disabled:cursor-not-allowed'
                        : errorMessage.length > 0
                        ? 'form-input w-full border-rose-300'
                        : 'form-input w-full'
                    "
                    type="password"
                    autoComplete="on"
                    v-model="password"
                    :disabled="isLoading"
                  />
                  <div
                    v-if="errorMessage.length > 0"
                    class="text-xs mt-1 text-rose-500"
                  >
                    {{ errorMessage }}
                  </div>
                </div>
              </div>
            </form>
            <div class="flex items-center justify-end mt-6">
              <button
                @click="submitLogin"
                v-show="!isLoading"
                class="btn bg-indigo-500 hover:bg-indigo-600 text-white ml-3"
              >
                Sign In
              </button>
              <button
                v-show="isLoading"
                class="
                  btn
                  bg-indigo-500
                  hover:bg-indigo-600
                  text-white
                  disabled:border-slate-200
                  disabled:bg-slate-100
                  disabled:text-slate-400
                  disabled:cursor-not-allowed
                  shadow-none
                "
                disabled
              >
                <svg
                  class="animate-spin w-4 h-4 fill-current shrink-0"
                  viewBox="0 0 16 16"
                >
                  <path
                    d="M8 16a7.928 7.928 0 01-3.428-.77l.857-1.807A6.006 6.006 0 0014 8c0-3.309-2.691-6-6-6a6.006 6.006 0 00-5.422 8.572l-1.806.859A7.929 7.929 0 010 8c0-4.411 3.589-8 8-8s8 3.589 8 8-3.589 8-8 8z"
                  />
                </svg>
                <span class="ml-2">Loading</span>
              </button>
            </div>
          </div>
        </div>
      </div>

      <!-- Image -->
      <div
        class="hidden md:block absolute top-0 bottom-0 right-0 md:w-1/2"
        aria-hidden="true"
      >
        <img
          class="object-cover object-center w-full h-full"
          src="storage/images/auth-image.jpg"
          width="760"
          height="1024"
          alt="Authentication"
        />
        <img
          class="
            absolute
            top-1/4
            left-0
            transform
            -translate-x-1/2
            ml-8
            hidden
            lg:block
          "
          src="storage/images/auth-decoration.png"
          width="218"
          height="224"
          alt="Authentication decoration"
        />
      </div>
    </div>
  </main>
</template>

<script>
import { ref, reactive, toRefs } from "vue";
import { postLogin } from "~/api/services/auth.js";
import { Inertia } from "@inertiajs/inertia";
import Toast3 from "~/components/toastr/Toast.vue";

export default {
  layout: null,
  name: "Signin",
  components: {
    Toast3,
  },
  setup() {
    const isLoading = ref(false);
    const errorMessage = ref("");
    const successMessage = ref("");
    const state = reactive({
      email: "",
      password: "",
    });

    const submitLogin = async () => {
      isLoading.value = true;
      errorMessage.value = "";
      successMessage.value = "";
      await postLogin(state)
        .then((res) => {
          Inertia.visit(route(`dashboard`));
        })
        .catch((err) => {
          errorMessage.value = err.response.data.message;
        })
        .finally(() => {
          isLoading.value = false;
        });
    };

    return {
      ...toRefs(state),
      isLoading,
      errorMessage,
      successMessage,
      submitLogin,
    };
  },
};
</script>